;;; guile-irrlicht --- FFI bindings for Irrlicht Engine
;;; Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>
;;;
;;; This file is part of guile-irrlicht.
;;;
;;; Guile-irrlicht is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU Lesser General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; Guile-irrlicht is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with guile-irrlicht.  If not, see
;;; <http://www.gnu.org/licenses/>.


(define-module (irrlicht irr)
  #:use-module (oop goops)
  #:use-module (irrlicht base)
  #:use-module (irrlicht foreign))


;; IReferenceCounted
(define-class <reference-counted> (<irrlicht-base>)
  (irr-class #:init-value "IReferenceCounted"))

(define-method (drop! (obj <reference-counted>))
  (let ((drop (get-irrlicht-proc "drop" obj)))
    (drop obj)))

(export <reference-counted> drop!)


;; IEventReceiver
(define-class <event-receiver> (<irrlicht-base>)
  (irr-class #:init-value "IEventReceiver"))

(export <event-receiver>)


;; SKeyMap
(define-class <key-map> (<irrlicht-base>)
  (irr-class #:init-value "SKeyMap"))

(export <key-map>)
