/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "color.h"
#include "gsubr.h"
#include "gui-in-out-fader.h"
#include "wrapped.h"

using namespace irr;

SCM
IGUIInOutFader_setColor (SCM in_out_fader,
                         SCM color,
                         SCM dest_color)
{
  gui::IGUIInOutFader* fader = (gui::IGUIInOutFader*)scm_to_irr_pointer (in_out_fader);
  if (dest_color == SCM_UNDEFINED)
    {
      fader->setColor (scm_to_color (color));
    }
  else
    {
      fader->setColor (scm_to_color (color),
                       scm_to_color (dest_color));
    }
  return SCM_UNSPECIFIED;
}

void
init_gui_in_out_fader (void)
{
  DEFINE_GSUBR ("IGUIInOutFader_setColor", 2, 1, 0, IGUIInOutFader_setColor);
}
